
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>memcache一致性hash的php实现方法_php技巧 / iVAN</title>

    <meta name="description" content="memcache一致性hash的php实现方法_php技巧 本文实例讲述了memcache一致性hash的php实现方法.分享给大家供大家参考.具体如下: 最近在看一些分布式方面的文章,所以就用php实现一致性hash来练练手,以前一般用的是最原始的hash取模做 分布式,当生产过程中添加或删除一台memcache都会造成数据的全部失效,一致性hash就是为了解决这个问题,把失效数据降到最低,相关资料可以 google一下! php实现效率有一定的缺失,如果要高效率,还是写扩展比较好 经测试,5个memcache,每个memcache生成100个虚拟节点">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">memcache一致性hash的php实现方法_php技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文实例讲述了memcache一致性hash的php实现方法。分享给大家供大家参考。具体如下：</p>
<p>最近在看一些分布式方面的文章，所以就用php实现一致性hash来练练手，以前一般用的是最原始的hash取模做 分布式，当生产过程中添加或删除一台memcache都会造成数据的全部失效，一致性hash就是为了解决这个问题，把失效数据降到最低，相关资料可以 google一下！</p>
<p>php实现效率有一定的缺失，如果要高效率，还是写扩展比较好</p>
<p>经测试，5个memcache，每个memcache生成100个虚拟节点，set加get1000次，与单个memcache直接set加get慢5倍，所以效率一般，有待优化！</p>
<p>在阅读本文之前，最好知道二分查找法。</p>
<p><strong>实现过程：</strong></p>
<p>memcache的配置 ip+端口+虚拟节点序列号 做hash,使用的是crc32,形成一个闭环。<br />
对要操作的key进行crc32<br />
二分法在虚拟节点环中查找最近的一个虚拟节点<br />
从虚拟节点中提取真实的memcache ip和端口，做单例连接</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;?php<br />
class memcacheHashMap {<br />
        private $_node = array();<br />
        private $_nodeData = array();<br />
        private $_keyNode = 0;<br />
        private $_memcache = null;<br />
        //每个物理服务器生成虚拟节点个数 [注：节点数越多，cache分布的均匀性越好，同时set get操作时，也更耗资源，10台物理服务器，采用200较为合理]<br />
        private $_virtualNodeNum = 200;<br />
        private function __construct() {<br />
                $config = array(//五个memcache服务器<br />
                                                '127.0.0.1:11211',<br />
                                                '127.0.0.1:11212',<br />
                                                '127.0.0.1:11213',<br />
                                                '127.0.0.1:11214',<br />
                                                '127.0.0.1:11215'<br />
                                        );<br />
                if (!$config) throw new Exception('Cache config NULL');<br />
                foreach ($config as $key =&gt; $value) {<br />
                        for ($i = 0; $i &lt; $this-&gt;_virtualNodeNum; $i++) {<br />
                                $this-&gt;_node[sprintf("%u", crc32($value . '_' . $i))] = $value . '_' . $i;//循环为每个memcache服务器创建200个虚拟节点<br />
                        }<br />
                }<br />
                ksort($this-&gt;_node);//创建出来的1000个虚拟节点按照键名从小到大排序<br />
        }<br />
        //实例化该类<br />
        static public function getInstance() {<br />
                static $memcacheObj = null;<br />
                if (!is_object($memcacheObj)) {<br />
                        $memcacheObj = new self();<br />
                }<br />
                return $memcacheObj;<br />
        }<br />
        //根据传来的键查找到对应虚拟节点的位置<br />
        private function _connectMemcache($key) {<br />
                $this-&gt;_nodeData = array_keys($this-&gt;_node);//所有的虚拟节点的键的数组<br />
                $this-&gt;_keyNode = sprintf("%u", crc32($key));//算出键的hash值<br />
                $nodeKey = $this-&gt;_findServerNode();//找出对应的虚拟节点<br />
                //如果超出环，从头再用二分法查找一个最近的，然后环的头尾做判断，取最接近的节点<br />
                if ($this-&gt;_keyNode &gt; end($this-&gt;_nodeData)) {<br />
                        $this-&gt;_keyNode -= end($this-&gt;_nodeData);<br />
                        $nodeKey2 = $this-&gt;_findServerNode();<br />
                        if (abs($nodeKey2 - $this-&gt;_keyNode) &lt; abs($nodeKey - $this-&gt;_keyNode))  $nodeKey = $nodeKey2;<br />
                }<br />
                var_dump($this-&gt;_node[$nodeKey]);<br />
                list($config, $num) = explode('_', $this-&gt;_node[$nodeKey]);<br />
                if (!$config) throw new Exception('Cache config Error');<br />
                if (!isset($this-&gt;_memcache[$config])) {<br />
                        $this-&gt;_memcache[$config] = new Memcache;<br />
                        list($host, $port) = explode(':', $config);<br />
                        $this-&gt;_memcache[$config]-&gt;connect($host, $port);<br />
                }<br />
                return $this-&gt;_memcache[$config];<br />
        }<br />
        //二分法根据给出的值找出最近的虚拟节点位置<br />
        private function _findServerNode($m = 0, $b = 0) {<br />
            $total = count($this-&gt;_nodeData);<br />
            if ($total != 0 &amp;&amp; $b == 0) $b = $total - 1;<br />
            if ($m &lt; $b){<br />
                $avg = intval(($m+$b) / 2);<br />
                if ($this-&gt;_nodeData[$avg] == $this-&gt;_keyNode) return $this-&gt;_nodeData[$avg];<br />
                elseif ($this-&gt;_keyNode &lt; $this-&gt;_nodeData[$avg] &amp;&amp; ($avg-1 &gt;= 0)) return $this-&gt;_findServerNode($m, $avg-1);<br />
                else return $this-&gt;_findServerNode($avg+1, $b);<br />
            }<br />
                if (abs($this-&gt;_nodeData[$b] - $this-&gt;_keyNode) &lt; abs($this-&gt;_nodeData[$m] - $this-&gt;_keyNode))  return $this-&gt;_nodeData[$b];<br />
                else return $this-&gt;_nodeData[$m];<br />
        }<br />
        public function set($key, $value, $expire = 0) {<br />
                return $this-&gt;_connectMemcache($key)-&gt;set($key, json_encode($value), 0, $expire);<br />
        }<br />
        public function add($key, $value, $expire = 0) {<br />
                return $this-&gt;_connectMemcache($key)-&gt;add($key, json_encode($value), 0, $expire);<br />
        }<br />
        public function get($key) {<br />
                return json_decode($this-&gt;_connectMemcache($key)-&gt;get($key), true);<br />
        }<br />
        public function delete($key) {<br />
                return $this-&gt;_connectMemcache($key)-&gt;delete($key);<br />
        }<br />
}<br />
$runData['BEGIN_TIME'] = microtime(true);<br />
//测试一万次set加get<br />
for($i=0;$i&lt;10000;$i++) {<br />
        $key = md5(mt_rand());<br />
        $b = memcacheHashMap::getInstance()-&gt;set($key, time(), 10);<br />
}<br />
var_dump(number_format(microtime(true) - $runData['BEGIN_TIME'],6));<br />
$runData['BEGIN_TIME'] = microtime(true); $m= new Memcache;<br />
$m-&gt;connect('127.0.0.1', 11211);<br />
for($i=0;$i&lt;10000;$i++) {<br />
        $key = md5(mt_rand());<br />
        $b = $m-&gt;set($key, time(), 0, 10);<br />
}<br />
var_dump(number_format(microtime(true) - $runData['BEGIN_TIME'],6));<br />
?&gt;</p>
<p>希望本文所述对大家的php程序设计有所帮助。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-16 00:03:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/php/" title="php">php</a>, <a href="https://www.iamivan.net/tag/hash/" title="hash">hash</a>, <a href="https://www.iamivan.net/tag/memcache/" title="memcache">memcache</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e8%87%b4%e6%80%a7/" title="一致性">一致性</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>memcache一致性hash的php实现方法_php技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyrB1Zp.html" rel="bookmark">memcache一致性hash的php实现方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 这篇文章主要介绍了memcache一致性hash的php实现方法,实例分析了memcache中hash一致性的实现原理与相关技巧,需要的朋友可以参考下     本文实例讲述了memcache一致性hash的php实现方法.分享给大家供大家参考.具体如下: 最近在看一些分布式方面的文章,所以就用php实现一致性hash来练练手,以前一般用的是最原始的hash取模做 分布式,当生产过程中添加或删除一台memcache都会造成数据的全部失效,一致性hash就是为了解决这个问题,把失效数据降到最低,相			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXq84Kz.html" rel="bookmark">PHP使用memcache缓存技术提高响应速度的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP使用memcache缓存技术提高响应速度的方法.分享给大家供大家参考.具体分析如下: php虽然己经做到很好很快了,但是如果大数据量时还是会有些卡了,这里介绍一下PHP中使用memcache缓存技术提高响应速度方法,有需要了解的朋友可参考. memcache既可以在linux下使用,也可以在windows系统下使用,当然首推linux系统,至于如何安装memcache,google一下就什么都出来了. 下面贴一段memcache的使用例子,代码如下: 复制代码 代码如下: &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZVOJz.html" rel="bookmark">PHP memcache扩展的三种安装方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于比较请看http://code.google.com/p/memcached/wiki/PHPClientComparison.推荐使用新的memcached,安装方法基本同下面,只是需要先安装libmemcached,如果还需要启用压缩,还需要安装zlib.用 PECL 编译共享 PECL 扩展库 $ pecl install extname 然后就是一长串的自动执行,最后程序告诉你You should add &quot;extension=memcache.so&quot; to php.ini			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLlBDM.html" rel="bookmark">用PHP实现多服务器共享SESSION数据的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP 实现多服务器共享 SESSION 数据 /google 的广告条--&gt; 一.问题起源 稍大一些的网站,通常都会有好几个服务器,每个服务器运行着不同功能的模块,使用不同的二级域名,而一个整体性强的网站,用户系统是统一的,即一套用户名.密码在整个网站的各个模块中都是可以登录使用的.各个服务器共享用户数据是比较容易实现的,只需要在后端放个数据库服务器,各个服务器通过统一接口对用户数据进行访问即可.但还存在一个问题,就是用户在这个服务器登录之后,进入另一个服务器的别的模块时,仍然需要重新登录,这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4kWY8p.html" rel="bookmark">PHP读取PPT文件的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP读取PPT文件的方法.分享给大家供大家参考,具体如下: 最近做一个和FLASH有关的东西,其中就要用到在网站上看PPT就像百度,豆丁网那样可以直接在网站上读,在网上搜了半天没搜到,都是些什么安装个软件什么的,PHP网站放到空间上,谁能让你在哪装软件呢?不是在瞎扯么?不过还好,最后在国外一个网站上搜到了一个解决思路,就是一个PHP操作PPT的类,当然这个网站还提供了操作OFFICES软件的其他类,不过是2007版的OFFICES,现把网址贴出来奉献给大家:http://phpp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNvONNM.html" rel="bookmark">Ubuntu server 11&period;04安装memcache及php使用memcache来存储session的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Ubuntu server 11.04安装memcache及php使用memcache来存储session的方法.分享给大家供大家参考,具体如下: 1.首先安装memcache服务端: sudo apt-get install memcached 安装完成后系统 自动启动了 memcached服务占用11211端口 如需重新配置11211端口的服务 需要关闭已开启的memcached服务 手动启动: memcached -d -m 128 -p 11211 -u memcache			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1NP83p.html" rel="bookmark">Discuz&excl;下Memcache缓存实现方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言:在PHP+MySQL架构的站点中,本文重点从MySQL的角度去分析如何使Discuz!论坛(或者类似的PHP+MySQL架构的程序)应对大访问量.同时给出一些使用Memcache去减轻MySQL压力的建议.其中很多数据是个人测试的结果,如有不同意见,敬请留言告之.另外由于个人思维的问题,行文比较跳跃,特此声明! 系统分析:单纯的从MySQL的角度出发,单台MySQL的数据库负载到每天上亿次的操作(每秒大概1100次MySQL操作,然后乘以86400)应该不是非常困难的事情.按照这个数据也就			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Wd3rz.html" rel="bookmark">php对文件进行hash运算的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php对文件进行hash运算的方法.分享给大家供大家参考.具体如下: 这段代码非常有用,如果你下载了一个文件,网站提供了hash结果,你可以对你下载下来的文件进行hash运算,以验证下载的文件是否正确. &lt;html&gt; &lt;head&gt; &lt;title&gt;Hash (Check) Files&lt;/title&gt; &lt;style type='text/css'&gt; #ok{color:green;} #nono{color:red;} &lt;/sty			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkmXx7b.html" rel="bookmark">php从memcache读取数据再批量写入mysql的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php从memcache读取数据再批量写入mysql的方法.分享给大家供大家参考.具体分析如下: 用 Memcache 可以缓解 php和数据库压力下面代码是解决高负载下数据库写入瓶颈问题,遇到最实用的:写入ip pv uv的时候,用户达到每分钟几万访问量,要记录这些数据,实时写入数据库必定奔溃. 用以下技术就能解决,还有如用户注册,同一时间断内,大量用户注册,可以缓存后一次性写入到数据库,代码如下: 复制代码 代码如下: public function cldata(){ $me			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPaJ0z.html" rel="bookmark" class="title">javascript &plus; DIV &plus;CSS 实现可拖动消息窗体</a>
					<div>
						css|javascript|可拖动 &lt;html&gt;&lt;head&gt;&lt;style&gt;    #div{}{width:300px;height:200px;color=re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMReZGb.html" rel="bookmark" class="title">&lpar;转&rpar;Oracle RMAN快速入门指南</a>
					<div>
						oracle|快速入门 前言这篇文章主要介绍RMAN的常用方法,其中包含了作者一些自己的经验,里面的实验也基本全在WIN 2K和ORACLE 8.1.6环境下测试成功(因为这个环境比较容易实现). 本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL233b.html" rel="bookmark" class="title">json&period;dumps python错误：&amp;&num;039&semi;utf8&amp;&num;039&semi; codec can&amp;&num;039&semi;t decode byte 0xe</a>
					<div>
						json.dumps python错误:'utf8' codec can't decode byte 0xe1 in position 5 -- 由于工作关系,要用python生成json数据储存为文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKE43M.html" rel="bookmark" class="title">xen虚拟化实战系列&lpar;六&rpar; xen虚拟机破解密码</a>
					<div>
						破解xen密码,初学xen当时觉得不好实现,总认为xen字符界面,不像图形界面一样出现grub菜单. xen虚拟化平台xm一个命令参数-c可以解决这个问题,可以出现字符界面grub菜单,本文只介绍一种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6mmgz.html" rel="bookmark" class="title">连接SQL SERVER的公共类VB&period;NET</a>
					<div>
						本文介绍连接SQL SERVER的公共类VB.NET. ************************************************************************ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPDvrz.html" rel="bookmark" class="title">Photoshop调出人物唯美的晨曦效果</a>
					<div>
						  Photoshop调出人物唯美的晨曦效果           原图 最终效果 1.打开原图素材大图,创建可选颜色调整图层,对黄色,绿色进行调整,参数及效果如下图.这一步给图片增加橙黄色. &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7DYBb.html" rel="bookmark" class="title">游戏开发设计要注意哪些问题</a>
					<div>
						  游戏开发设计必须注意哪些问题?游戏开发设计的黄金法则!未来是一个游戏的时代,所以现在很多人都开始从事游戏开发这方面的工作,可是在当下的时代新的游戏不断的被开发出来,可是有多少游戏能够真的吸引到玩家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wDRNp.html" rel="bookmark" class="title">360安全卫士初始化失败及不能正常安装解决方法</a>
					<div>
						360安全卫士是一款恶意软件清理工具,有了它能使我们的系统更加清爽,不再受流氓软件的恶意骚扰.诸如3721.网页恶意捆绑等都能使之瞬间消失.但是并不是有了它就能高枕无忧,毕竟现在网上的&quot;手段 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7QAAM.html" rel="bookmark" class="title">无线网状态下修改IP地址和DNS</a>
					<div>
						用一台连接上无线网络的电脑,你可以在电脑端&quot;开始&quot;-&quot;运行&quot;,输入cmd,在弹出的 cmd.exe中输入ipconfig /all就可以看到网络配置值了.你可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1E37z.html" rel="bookmark" class="title">如何设置word2013背景颜色</a>
					<div>
						  设置word背景颜色的方法一: 步骤一:打开一个word文档,点击开始,如图: 步骤二:把所想加的文字选中,按照键头点击,即可,如图: 步骤三:方法2,按照键头所指的点击,就可以得到下图的效果:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKRAvp.html" rel="bookmark" class="title">javascript中数组的冒泡排序使用示例</a>
					<div>
						 数组的冒泡排序很实用,不过还是有些同学们不会,于是在本文为大家详细介绍下,感兴趣的朋友不要错过  代码如下: &lt;html&gt;  &lt;head&gt;  &lt;title&gt;数组的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN11r7b.html" rel="bookmark" class="title">Windows 8 中按流量计费的宽带连接设置方法</a>
					<div>
						  1.桌面下单击右下角的网络图标.参见下图 2.右键正在连接的无线网络.参见下图 3.在弹出菜单里单机选择&quot;设为按流量计费的连接&quot;.参见下图 4.然后单机选择&quot;显示预计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZE3Pb.html" rel="bookmark" class="title">win7设置环回接口和安装找不到指定文件</a>
					<div>
						  现今很多人的生活都离不开电脑,作为高科技产物的电脑也确实为人们的生活增添了不少色彩,但同时也带来了某些知识难题,这对于那些对电脑知识不了解的网友们可是一个不小的烦恼.就像是在win7系统中设置环回 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o2dmb.html" rel="bookmark" class="title">360安全卫士下载卡巴斯基失败怎么办</a>
					<div>
						由于网络问题,有的时候在360安全卫士下载卡巴斯基软件的过程中会中断导致此次下载失败. 如果下载失败,用户可以通过两种方式重新下载: &lt;1&gt; 重新打开360安全卫士程序病毒查杀界面,点下载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGlxap.html" rel="bookmark" class="title">Windows XP超级管理员的密码问题</a>
					<div>
						对于自己的电脑有时候总是有一些私人的东西不希望别人看到这应该怎么办呢?我们大家经常做的事情就是设置密码,这样就只要自己知道密码别人就没办法私自动用自己的电脑啦,可以关于管理员密码的问题你们了解多少呢? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo705db.html" rel="bookmark" class="title">联想怎么恢复预装win8&period;1的中文版系统？</a>
					<div>
						  很多人买了联想预装windows8.1中文版系统的电脑,由于windows8.1体验不好,改装成其它系统了,一段时间后想恢复为原厂预装的正版windows8.1,去联想售后恢复,如果电脑购买超过一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLBAWb.html" rel="bookmark" class="title">Erlang千万级用户游戏框架（Openpoker）源码文件分析清单</a>
					<div>
						openpoker源码 erlang写的网游服务器源码,OpenPoker是一个大型多人扑克网游,内建支持了容错能力,负载平衡和无限制的规模大小.本文是openpoker源码文件功能的一个清单式说明: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVglBb.html" rel="bookmark" class="title">【3万患者11万图像14类病理】NIH公开大规模胸部X光数据集</a>
					<div>
						胸部X光检查是最常见而且最具成本效益的医学影像检查之一.但是,胸部X光检查的临床诊断很具挑战性,有时被认为比胸部CT成像更难诊断.过去一些有前景的工作已经被报道过,特别是最近在结核病(TB)分类方面的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6yjAb.html" rel="bookmark" class="title">ios-使用Persistence的viewDidLoad</a>
					<div>
						问题描述 使用Persistence的viewDidLoad 在viewDidLoad事件中应用在这行崩溃: NSKeyedUnarchiver *unarchiver = [[NSKeyedUnar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7DRvz.html" rel="bookmark" class="title">界面-安卓关于监听输入法弹出与隐藏然后做相应的事情</a>
					<div>
						问题描述 安卓关于监听输入法弹出与隐藏然后做相应的事情 当我开启登录界面,edittext自动获取焦点,输入法显示,输入法显示的时候我要做一些控件动画,当手动按下隐藏键盘的的时候,我又要恢复以前的状态 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RQ4Dz.html" rel="bookmark" class="title">html-HTML页面转变成JSP时排版出现问题</a>
					<div>
						问题描述 HTML页面转变成JSP时排版出现问题 HTML运行时排版是好的,但是我把HTML中内容和样式属性导入到JSP后,页面的排版就乱了,希望大神能帮我解决一下,谢谢, 解决方案 这个要具体看才可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Z66AM.html" rel="bookmark" class="title">帝度冰箱的&OpenCurlyDoubleQuote;Smart智能系统&rdquo;提供给消费者冷藏解决方案</a>
					<div>
						&quot;保鲜&quot;是冰箱最原始的功能,是消费者认可和购买冰箱最本质的初衷.但是现代生活的快节奏与丰富性使消费者对保鲜提出了更多样.更细致的要求.如何满足这些要求是对冰箱智能化水平和制造工艺的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7V1WM.html" rel="bookmark" class="title">未来在哪？腾讯内部人士曝光微信商业走向和机会</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 以下内容来自在腾讯当官的一个兄弟,是他对于微信商业趋势和机会的分享.独家分享,供各位朋友参考. 1.微信将进一步控制订阅号的内容方向,政经.金融 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RQ87z.html" rel="bookmark" class="title">电子商务年终盘点：全年交易总量同比倍增</a>
					<div>
						来自CNZZ的6184.html&quot;&gt;数据表明,电子商务在2009年迅猛增长,全年交易总量为2008年的2倍以上,电子商务站点数达到1.56万家,访客量同比增长61.29%,其中B2C站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx02QBM.html" rel="bookmark" class="title">OpenStack组件Swift单机搭建（基于Keystone）</a>
					<div>
						安装环境:Ubuntu 16.04 需要有两块硬盘(一块为系统盘,一块用于安装SWIFT) 需要有IP地址 环境准备 修改hosts文件 安装相关服务 修改hosts 编辑 /etc/hosts,添加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqdg7p.html" rel="bookmark" class="title">在做音乐管理系统的&OpenCurlyDoubleQuote;下载&rdquo;时，如何可以实现在安装了&OpenCurlyDoubleQuote;迅雷&rdquo;的计算机上使用迅雷下载？</a>
					<div>
						问题描述 在做音乐管理系统的&quot;下载&quot;时,如何可以实现在安装了&quot;迅雷&quot;的计算机上使用迅雷下载?我在做&quot;音乐下载系统&quot;时想使用&quot;迅雷& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwDg0M.html" rel="bookmark" class="title">unity 报错说是内部编译错误，怎么办啊</a>
					<div>
						问题描述 unity 报错说是内部编译错误,怎么办啊 Internal compiler error. See the console log for more information. output ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwAZOM.html" rel="bookmark" class="title">fortune 命令简介</a>
					<div>
						美国中餐馆的最后一道菜,往往是小甜饼,叫做&quot;幸运饼&quot;(fortune cookie). 里面有一张纸条,写着人生格言. 这种形式的格言,显然很受欢迎.早在1979年,就有人写了一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqYGxb.html" rel="bookmark" class="title">数字媒体时代</a>
					<div>
						-角色定位模糊的时代 数字媒体时代,模糊了数字媒体.广告客户.广告公司的角色边界. 2010年7月15日,由第一财经与易传媒共同主办了一场盛况空前的&quot;中国数字媒体峰会&quot;,邀请到来自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4440Pz.html" rel="bookmark" class="title">控制&amp;amp&semi;quot&semi;纵打&amp;amp&semi;quot&semi;、 横打&rdquo;和&OpenCurlyDoubleQuote;页面的边距&comma;去掉页眉&comma;分页&period;&period;&period;打印大全</a>
					<div>
						WEB打印大全:(转截梅花雨)1.控制&quot;纵打&quot;. 横打&quot;和&quot;页面的边距.(1)&lt;script defer&gt;function SetPrintSett ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
